VERSION 5.00
Begin VB.Form Sample 
   Caption         =   "Sample"
   ClientHeight    =   1005
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2085
   LinkTopic       =   "Form1"
   ScaleHeight     =   1005
   ScaleWidth      =   2085
   StartUpPosition =   3  'Windows ̊l
End
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*****************************************************************************
'* aisa25s.bas                                                               *
'*                                                                           *
'* aISA-A25Tv\[X                                                    *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1999/03/09                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szA25 = "aISA-A25"

Private Sub Form_Load()

    Dim wLogSlot As Integer     ' foCXi[

    '*----------------------------------------------*'
    '*  Jn                                    *'
    '*----------------------------------------------*'
    If StartProc(wLogSlot) = False Then Exit Sub

    '*----------------------------------------------*'
    '*  A'D                                     *'
    '*----------------------------------------------*'
    If AdProc(wLogSlot) = False Then
        EndProc (wLogSlot)
        Exit Sub
    End If

    '*----------------------------------------------*'
    '*  D'A                                     *'
    '*----------------------------------------------*'
    If DaProc(wLogSlot) = False Then
        EndProc (wLogSlot)
        Exit Sub
    End If

    '*----------------------------------------------*'
    '*  PIO                                     *'
    '*----------------------------------------------*'
    If PioProc(wLogSlot) = False Then
        EndProc (wLogSlot)
        Exit Sub
    End If

    '*----------------------------------------------*'
    '*  I                                    *'
    '*----------------------------------------------*'
    If EndProc(wLogSlot) = False Then Exit Sub

End Sub

'*--------------------------------------------------------------------------*'
'*  Jn                                                                *'
'*--------------------------------------------------------------------------*'
Private Function StartProc(ByRef pwLogSlot As Integer) As Boolean

    StartProc = False

    Dim strbuf As String                    ' ƃobt@
    Dim dwDLLVer As Long, dwDrvVer As Long  ' o[W
    Dim bResult As Boolean                  ' 
    Dim wLogSlot As Integer                 ' _Xbg
    Dim ri As AISA25RESOURCE                ' \[X
    Dim wNumBoard As Integer                ' 䂷{[h
    Dim dwSwitchValue As Long               ' BSN

    '*----------------------------------------------*'
    '*  aisa25.dll ̎gp錾                     *'
    '*----------------------------------------------*'
    If Aisa25wDllOpen() = False Then
        ErrorMessage (AISA25_SLOT_AUTO)
        Exit Function           ' aisa25.dll ̃[hɎs܂
    End If

    '*----------------------------------------------*'
    '*  o[Wԍ\                          *'
    '*  aISA-A25 DLL,Driver̃o[Wԍ擾     *'
    '*----------------------------------------------*'
    If Aisa25wGetVersion(dwDLLVer, dwDrvVer) = False Then
        ErrorMessage (AISA25_SLOT_AUTO)
        Exit Function
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDLLVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

    '*----------------------------------------------*'
    '*  aISA-A25̎gp錾                        *'
    '*----------------------------------------------*'
    wLogSlot = AISA25_SLOT_AUTO         ' gp̃foCXT܂B

    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    ' 3ԖڂɃZbgẮAbZ[WID̊ƂȂlłB
    ' ۂ̃bZ[WID͂̊lɃItZbg(WM_EOCȂ)̂ƂȂ܂B
    ' 4Ԗڂ̈ɂ 0 Zbg܂B
    bResult = Aisa25wCreate(wLogSlot, 0, &H6401, 0)

    If bResult = False Then             ' foCX܂B
        ErrorMessage (AISA25_SLOT_AUTO)
        Exit Function
    End If

    strbuf = "aISA-A25 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

    '*----------------------------------------------*'
    '*  \[X擾                          *'
    '*----------------------------------------------*'
    If Aisa25wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    '*----------------------------------------------*'
    '*  䂷{[h擾                      *'
    '*----------------------------------------------*'
    If Aisa25wGetNumBoard(wLogSlot, wNumBoard) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    '*----------------------------------------------*'
    '*  BSN ̒l擾                              *'
    '*----------------------------------------------*'
    If Aisa25wGetSwitchValue(wLogSlot, dwSwitchValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "Board Name: " + szA25 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters(1)) + Chr(10) + _
             "Num Board: " + Str(wNumBoard) + Chr(10) + _
             "BSN: &H" + Hex(dwSwitchValue)

    ResultMessage (strbuf)

    ' _Xbgf[^ZbgĕԂ܂B
    pwLogSlot = wLogSlot

    StartProc = True

End Function

'*--------------------------------------------------------------------------*'
'*  I                                                                *'
'*--------------------------------------------------------------------------*'
Private Function EndProc(ByVal wLogSlot As Integer) As Boolean

    EndProc = False

    '*----------------------------------------------*'
    '*  aISA-A25 ̎gpJ                       *'
    '*----------------------------------------------*'
    If Aisa25wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("aISA-A25 Closed")

    '*----------------------------------------------*'
    '*  aisa25.dll ̎gpJ                     *'
    '*----------------------------------------------*'
    If Aisa25wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Function           ' aisa25.dll ̃A[hɎs܂B
    End If

    EndProc = True

End Function

'*--------------------------------------------------------------------------*'
'*  A'D                                                                 *'
'*--------------------------------------------------------------------------*'
Private Function AdProc(ByVal wLogSlot As Integer) As Boolean

    AdProc = False

    Dim strbuf As String                                ' ƃobt@
    Dim che(1 To AISA25_AD_CH_ADDR_MAX) As AISA25ADCHE  ' CH Gg RAM
    Dim dwChCount As Long                               ' CH Gg
    Dim mode As AISA25ADMODE                            ' TvO샂[h
    Dim dwNumData As Long                               ' TvOf[^
    Dim dwStatus As Long                                ' TvOXe[^X

    Dim wData() As Integer                              ' TvOf[^
    Dim wChCur As Integer                               ' `lCNg
    Dim wChFirst As Integer
    Dim wChLast As Integer
    Dim i As Long

    '*----------------------------------------------*'
    '*  A'D Ro[^̃Lu[V          *'
    '*----------------------------------------------*'
    If Aisa25wAdc(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("A/D Ro[^Lu[V")

    '*----------------------------------------------*'
    '*  A'D CH Gg RAM ̓e擾            *'
    '*----------------------------------------------*'
    dwChCount = AISA25_AD_CH_ADDR_MAX       ' CH Gg

    If Aisa25wAdGetChEntry(wLogSlot, dwChCount, che) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "A/D CH Gg RAM ̓e擾" + Chr(10)

    For i = 1 To dwChCount
        strbuf = strbuf + "Addr:&H" + Hex(i - 1) + _
                        "  CH:" + Str(che(i).dwChAnalog + 1) + _
                        "  SdBu:" + Str(che(i).dwSdBu) + _
                        "  Gain:" + Str(che(i).dwGain) + Chr(10)
    Next i

    ResultMessage (strbuf)

    '*----------------------------------------------*'
    '*  A'D CH Gg RAM ̓o^                  *'
    '*----------------------------------------------*'
    For i = 1 To dwChCount
        che(i).dwGain = AISA25_AD_GAIN_50       ' QCύX
    Next i

    If Aisa25wAdSetChEntry(wLogSlot, dwChCount, che) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("A/D CH Gg RAM ̓eo^")

    '*----------------------------------------------*'
    '*  A'D TvO샂[hݒ              *'
    '*----------------------------------------------*'
    mode.dwMode = AISA25_AD_MODE_01             ' 샂[h
    mode.dwChAddrFirst = AISA25_AD_CH_0H        ' TvOJn`lAhX
    mode.dwChAddrLast = AISA25_AD_CH_FH         ' TvOI`lAhX
    mode.dwSelCnvRate = AISA25_AD_RATE_HIGH     ' ϊx
    mode.dwSelClock = AISA25_AD_CLOCK_10M       ' TvONbN
    mode.dwTimer = 100                          ' TvO^C}
    mode.dwCount = 50                           ' TvO񐔂ݒ
    mode.dwBuffer = 50                          ' obt@TCY
    mode.dwScn = 0                              ' e{[h EAB XLԍ(SCN)
                                                ' }X^{[hɃ^[Qbg{[h
                                                ' ڑĂꍇ́ASCN ݒ
                                                ' ĂB

    If Aisa25wAdSetMode(wLogSlot, mode) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("A/D TvO샂[hݒ")

    '*----------------------------------------------*'
    '*  A'D TvO̊Jn                      *'
    '*----------------------------------------------*'
    If Aisa25wAdStartSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("A/D TvOJn")

    '*----------------------------------------------*'
    '*  A'D TvO̒~                      *'
    '*----------------------------------------------*'
    If Aisa25wAdStopSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("A/D TvO~")

    '*----------------------------------------------*'
    '*  A'D TvȌԂ擾                *'
    '*----------------------------------------------*'
    If Aisa25wAdGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "A/D TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)

    ResultMessage (strbuf)

    ' TvOf[^Ƃ
    If dwNumData = 0 Then
        AdProc = True
        Exit Function
    End If

    '*----------------------------------------------*'
    '*  A'D TvOf[^̎擾                *'
    '*----------------------------------------------*'
    ReDim wData(1 To dwNumData)                         ' ̈m

    If Aisa25wAdGetData(wLogSlot, dwNumData, wData) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    wChCur = mode.dwChAddrFirst     ' Jn`lAhX
    wChFirst = mode.dwChAddrFirst   ' Jn`lAhX
    wChLast = mode.dwChAddrLast     ' I`lAhX

    strbuf = "A/D TvOf[^擾" + Chr(10)

    For i = 1 To dwNumData
        strbuf = strbuf + "Addr:&H" + Hex(wChCur) + _
                          " CH" + Str(che(wChCur + 1).dwChAnalog + 1) + _
                          ";&H" + Hex(wData(i)) + "  "

        If i Mod 4 = 0 Then ' 4 Ŋ؂
            strbuf = strbuf + Chr(10)
        End If

        ' ̎QƃAhX
        wChCur = AdProcGetNextChAddr(wChFirst, wChLast, wChCur)
    Next i

    ResultMessage (strbuf)

    AdProc = True

End Function

'*--------------------------------------------------------------------------*'
'*  D'A                                                                 *'
'*--------------------------------------------------------------------------*'
Private Function DaProc(ByVal wLogSlot As Integer) As Boolean

    DaProc = False

    Dim strbuf As String                ' ƃobt@
    Dim dwSelClock As Long              ' TvONbN
    Dim dwTimer As Long                 ' TvO^C}
    Dim dwDaMode As Long                ' D/A [h
    Dim dwDataCount As Long             ' D/A f[^o^
    Dim wDataEntry() As Integer         ' D/A TvOf[^
    Dim wDaData     As Integer          ' D/A f[^

    '*----------------------------------------------*'
    '*  D'A TvOx̐ݒ                  *'
    '*----------------------------------------------*'
    dwSelClock = AISA25_DA_CLOCK_10M    ' 10MHz
    dwTimer = 1000

    If Aisa25wDaSetRateSampling(wLogSlot, dwSelClock, dwTimer) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("D/A TvONbNݒ")

    '*----------------------------------------------*'
    '*  D'A g`f[^̓o^                        *'
    '*----------------------------------------------*'
    dwDaMode = AISA25_DA_MODE_ALL       ' ALL [hŃf[^o^

                                        ' g`f[^쐬
    Call DaProcMakeSquareData(dwDataCount, wDataEntry)

    If Aisa25wDaSetDataEntry(wLogSlot, dwDaMode, dwDataCount, wDataEntry) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("D/A g`f[^o^")

    '*----------------------------------------------*'
    '*  D'A TvOJn                        *'
    '*----------------------------------------------*'
    dwDaMode = AISA25_DA_MODE_ALL       ' ALL [hŃTvO܂B

    If Aisa25wDaStartSampling(wLogSlot, dwDaMode) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("D/A TvOJn")

    '*----------------------------------------------*'
    '*  D'A TvO~                        *'
    '*----------------------------------------------*'
    If Aisa25wDaStopSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    ResultMessage ("D/A TvO~")

    '*----------------------------------------------*'
    '*  D/A f[^𒼐ڏo                        *'
    '*----------------------------------------------*'
    wDaData = &H8000

    If Aisa25wDaSetData(wLogSlot, wDaData) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "D/Af[^o" + Chr(10) + _
             "Data: &H" + Hex(wDaData)

    ResultMessage (strbuf)

    DaProc = True

End Function

'*--------------------------------------------------------------------------*'
'*  PIO                                                                 *'
'*--------------------------------------------------------------------------*'
Private Function PioProc(ByVal wLogSlot As Integer) As Boolean

    PioProc = False

    Dim strbuf As String                ' ƃobt@
    Dim dwEIn1 As Long                  ' ėp
    Dim dwEIn2 As Long
    Dim dwEIn3 As Long
    Dim dwEOut1 As Long                 ' ėpo
    Dim dwEOut2 As Long
    Dim dwEOut3 As Long

    '*----------------------------------------------*'
    '*  ėpo͂ǂݍ                      *'
    '*----------------------------------------------*'
    If Aisa25wGetEIn(wLogSlot, dwEIn1, dwEIn2, dwEIn3) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "ėp͂̓e" + Chr(10) + _
             "EIn1: &H" + Hex(dwEIn1) + Chr(10) + _
             "EIn2: &H" + Hex(dwEIn2) + Chr(10) + _
             "EIn3: &H" + Hex(dwEIn3)

    ResultMessage (strbuf)

    '*----------------------------------------------*'
    '*  ėpo͂֏o                            *'
    '*----------------------------------------------*'
    dwEOut1 = AISA25_EIO_ON
    dwEOut2 = AISA25_EIO_OFF
    dwEOut3 = AISA25_EIO_ON

    If Aisa25wSetEOut(wLogSlot, dwEOut1, dwEOut2, dwEOut3) = False Then
        ErrorMessage (wLogSlot)
        Exit Function
    End If

    strbuf = "ėpo͂̓e" + Chr(10) + _
             "EOut1: &H" + Hex(dwEOut1) + Chr(10) + _
             "EOut2: &H" + Hex(dwEOut2) + Chr(10) + _
             "EOut3: &H" + Hex(dwEOut3)

    ResultMessage (strbuf)

    PioProc = True

End Function

'*--------------------------------------------------------------------------*'
'* `lCNgTvO̎̎QƃAhX                   *'
'*--------------------------------------------------------------------------*'
Private Function AdProcGetNextChAddr(ByVal wFirst As Integer, ByVal wLast As Integer, ByVal wCur As Integer) As Integer

    ' Jn`lAhXƏI`lAhX
    ' ȂCNgȂ
    AdProcGetNextChAddr = wCur

    If wFirst = wLast Then Exit Function

    wCur = wCur + 1
    
    ' ŏIAhX𒴂A擪AhXԂ
    AdProcGetNextChAddr = AISA25_AD_CH_ADDR_FIRST
    
    If AISA25_AD_CH_ADDR_LAST < wCur Then Exit Function

    ' JnAhXIAhX傫A
    ' JnAhXCNgl傫ꍇ
    AdProcGetNextChAddr = wCur
    
    If wFirst > wLast And wCur > wFirst Then Exit Function

    ' IAhX傫ꍇ
    AdProcGetNextChAddr = AISA25_AD_CH_ADDR_FIRST
    
    If wLast < wCur Then Exit Function

    AdProcGetNextChAddr = wCur

End Function

'*--------------------------------------------------------------------------*'
'*    `gf[^̍쐬                                                *'
'*          -10V -> +10V                                                    *'
'*--------------------------------------------------------------------------*'
Private Sub DaProcMakeSquareData(ByRef pdwDataCount As Long, ByRef pwData() As Integer)
    
    Dim wData As Integer, wWork As Integer
    Dim i As Long

    ReDim pwData(1 To 512)

    ' -10V
    wData = &H0
    wWork = Not wData
    wWork = wWork And &H8000
    wData = wData And &H7FFF
    wData = wData Or wWork
    
    For i = 1 To 256
        
        pwData(i) = wData
    
    Next i

    ' +10V
    wData = &HFFFF
    wWork = Not wData
    wWork = wWork And &H8000
    wData = wData And &H7FFF
    wData = wData Or wWork
    
    For i = 257 To 512
        
        pwData(i) = wData
    
    Next i
    
    pdwDataCount = 512

End Sub

'*--------------------------------------------------------------------------*'
'*  ʂ\                                                          *'
'*--------------------------------------------------------------------------*'
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'*--------------------------------------------------------------------------*'
'*  G[bZ[W\                                                  *'
'*--------------------------------------------------------------------------*'
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa25wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA25_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-A25 error" + Chr(10) + Chr(10) + _
                "Error code: " + _
                Str(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
